Index: /trunk/Cocoa/F-Script Anywhere/Source/Bundle Loader-Info.plist
===================================================================
--- /trunk/Cocoa/F-Script Anywhere/Source/Bundle Loader-Info.plist	(revision 221)
+++ /trunk/Cocoa/F-Script Anywhere/Source/Bundle Loader-Info.plist	(revision 222)
@@ -22,5 +22,5 @@
 	<string>FSAL</string>
 	<key>CFBundleVersion</key>
-	<string>1.2b1</string>
+	<string>1.3</string>
 </dict>
 </plist>
Index: /trunk/Cocoa/F-Script Anywhere/Source/Bundle-Info.plist
===================================================================
--- /trunk/Cocoa/F-Script Anywhere/Source/Bundle-Info.plist	(revision 221)
+++ /trunk/Cocoa/F-Script Anywhere/Source/Bundle-Info.plist	(revision 222)
@@ -22,5 +22,5 @@
 	<string>FSAB</string>
 	<key>CFBundleVersion</key>
-	<string>1.2b1</string>
+	<string>1.3</string>
 </dict>
 </plist>
Index: /trunk/Cocoa/F-Script Anywhere/Source/DeVercruesseProcess.m
===================================================================
--- /trunk/Cocoa/F-Script Anywhere/Source/DeVercruesseProcess.m	(revision 221)
+++ /trunk/Cocoa/F-Script Anywhere/Source/DeVercruesseProcess.m	(revision 222)
@@ -111,8 +111,8 @@
     bundleURL = CFURLCreateWithFileSystemPath(NULL, bundleLoc, kCFURLPOSIXPathStyle, NO);
     bundleRef = CFBundleCreate(NULL, bundleURL);
+    CFRelease(bundleURL);
 
     if (bundleRef == NULL) {
         BOOL isDir;
-        CFRelease(bundleURL);
         if ([[NSFileManager defaultManager] fileExistsAtPath: [self loc] isDirectory: &isDir] && !isDir)
             return [self loc];
Index: /trunk/Cocoa/F-Script Anywhere/Source/FSAApp.mm
===================================================================
--- /trunk/Cocoa/F-Script Anywhere/Source/FSAApp.mm	(revision 221)
+++ /trunk/Cocoa/F-Script Anywhere/Source/FSAApp.mm	(revision 222)
@@ -239,4 +239,6 @@
     if (err != noErr)
         [self installationError: err inAppWithPID: pid];
+    else
+        [appList didPatchProcessID: pid];
 }
 
Index: /trunk/Cocoa/F-Script Anywhere/Source/FSAAppList.m
===================================================================
--- /trunk/Cocoa/F-Script Anywhere/Source/FSAAppList.m	(revision 221)
+++ /trunk/Cocoa/F-Script Anywhere/Source/FSAAppList.m	(revision 222)
@@ -132,5 +132,5 @@
 {
     [tableView reloadData];
-    [self tableView: tableView shouldSelectRow: [tableView selectedRow]];
+//    [self tableView: tableView shouldSelectRow: [tableView selectedRow]];
 }
 
@@ -143,6 +143,8 @@
 {
     DeVercruesseProcess *app = [self _applicationForPID: pid];
-    [patchingApps removeObject: app];
-    [patchedApps addObject: app];
+    if(app){
+	[patchingApps removeObject: app];
+	[patchedApps addObject: app];
+    }
     [self _processStatusChanged];
 }
@@ -170,6 +172,9 @@
         return NO;
     
-    if (read(fd, &pefHeader, sizeof(pefHeader)) != sizeof(pefHeader))
+    if (read(fd, &pefHeader, sizeof(pefHeader)) != sizeof(pefHeader)){
+	close(fd);
 	return NO;
+    } else
+	close(fd);
     
     if (pefHeader.tag1 != kPEFTag1 || pefHeader.tag2 != kPEFTag2)
@@ -229,5 +234,4 @@
      }
      */
-    
     if ( ![app isBackgroundOnly] &&
 	 ( ( [app isCocoa] && ![self appIsPEF: app]) ||
@@ -461,5 +465,5 @@
     id e = [cocoaApps objectEnumerator];
     while(anApp = [e nextObject]){
-	if([alwaysApps containsObject:[anApp name]] && ![patchedApps containsObject:anApp]){
+	if([alwaysApps containsObject:[anApp name]]){
 	    [NSApp installBundleInAppWithPID:[anApp pid]];
 	}
Index: /trunk/Cocoa/F-Script Anywhere/Source/Info-Application.plist
===================================================================
--- /trunk/Cocoa/F-Script Anywhere/Source/Info-Application.plist	(revision 221)
+++ /trunk/Cocoa/F-Script Anywhere/Source/Info-Application.plist	(revision 222)
@@ -8,6 +8,6 @@
 	<string>F-Script Anywhere</string>
 	<key>CFBundleGetInfoString</key>
-	<string>F-Script Anywhere 1.2b1,
-© 2002–04 Nicholas Riley</string>
+	<string>F-Script Anywhere 1.3,
+© 2002–06 Nicholas Riley</string>
 	<key>CFBundleIconFile</key>
 	<string>Application icon</string>
@@ -21,9 +21,9 @@
 	<string>APPL</string>
 	<key>CFBundleShortVersionString</key>
-	<string>1.2b1</string>
+	<string>1.3</string>
 	<key>CFBundleSignature</key>
 	<string>FSAn</string>
 	<key>CFBundleVersion</key>
-	<string>1.2b1</string>
+	<string>1.3</string>
 	<key>NSMainNibFile</key>
 	<string>MainMenu</string>
Index: /trunk/Cocoa/F-Script Anywhere/Source/VERSION
===================================================================
--- /trunk/Cocoa/F-Script Anywhere/Source/VERSION	(revision 221)
+++ /trunk/Cocoa/F-Script Anywhere/Source/VERSION	(revision 222)
@@ -1,1 +1,1 @@
-1.1.6d1
+1.3