Index: trunk/Cocoa/F-Script Anywhere/Source/F-Script Anywhere.xcodeproj/project.pbxproj
===================================================================
--- trunk/Cocoa/F-Script Anywhere/Source/F-Script Anywhere.xcodeproj/project.pbxproj	(revision 223)
+++ trunk/Cocoa/F-Script Anywhere/Source/F-Script Anywhere.xcodeproj/project.pbxproj	(revision 224)
@@ -10,5 +10,4 @@
 		25EADA9609CD2D7100BCD8E1 /* bytesex.c in Sources */ = {isa = PBXBuildFile; fileRef = 25EADA9509CD2D7100BCD8E1 /* bytesex.c */; };
 		E14C18BD05A4DE25000D4AF3 /* FSAInterpreterPanel.nib in Resources */ = {isa = PBXBuildFile; fileRef = F5680F7A020D0D0401AEEC37 /* FSAInterpreterPanel.nib */; };
-		E14C18BE05A4DE29000D4AF3 /* FSAViewAssociationPanel.nib in Resources */ = {isa = PBXBuildFile; fileRef = F5FF50C002E53EE101AEEDB1 /* FSAViewAssociationPanel.nib */; };
 		E14C18BF05A4F013000D4AF3 /* Bullseye menu cursor.tiff in Resources */ = {isa = PBXBuildFile; fileRef = F5694E2702E96FFE01AEEDB1 /* Bullseye menu cursor.tiff */; };
 		E14C1ECF05A8DB19000D4AF3 /* Ellipsis.tiff in Resources */ = {isa = PBXBuildFile; fileRef = E14C1ECE05A8DB19000D4AF3 /* Ellipsis.tiff */; };
@@ -214,5 +213,4 @@
 		F5FF50BC02E53B9E01AEEDB1 /* FSAViewAssociationController.h */ = {isa = PBXFileReference; fileEncoding = 30; lastKnownFileType = sourcecode.c.h; path = FSAViewAssociationController.h; sourceTree = "<group>"; };
 		F5FF50BD02E53B9E01AEEDB1 /* FSAViewAssociationController.m */ = {isa = PBXFileReference; fileEncoding = 30; lastKnownFileType = sourcecode.c.objc; path = FSAViewAssociationController.m; sourceTree = "<group>"; };
-		F5FF50C102E53EE101AEEDB1 /* English */ = {isa = PBXFileReference; lastKnownFileType = wrapper.nib; name = English; path = English.lproj/FSAViewAssociationPanel.nib; sourceTree = "<group>"; };
 /* End PBXFileReference section */
 
@@ -294,5 +292,4 @@
 				29B97318FDCFA39411CA2CEA /* MainMenu.nib */,
 				F5680F7A020D0D0401AEEC37 /* FSAInterpreterPanel.nib */,
-				F5FF50C002E53EE101AEEDB1 /* FSAViewAssociationPanel.nib */,
 				E1EE9A2F0575769600F2D92C /* Info-Application.plist */,
 				089C165CFE840E0CC02AAC07 /* InfoPlist.strings */,
@@ -694,5 +691,4 @@
 				E1F3DF920579172A00E952A5 /* FSA.strings in Resources */,
 				E14C18BD05A4DE25000D4AF3 /* FSAInterpreterPanel.nib in Resources */,
-				E14C18BE05A4DE29000D4AF3 /* FSAViewAssociationPanel.nib in Resources */,
 				E14C18BF05A4F013000D4AF3 /* Bullseye menu cursor.tiff in Resources */,
 			);
@@ -832,12 +828,4 @@
 			);
 			name = FSAInterpreterPanel.nib;
-			sourceTree = "<group>";
-		};
-		F5FF50C002E53EE101AEEDB1 /* FSAViewAssociationPanel.nib */ = {
-			isa = PBXVariantGroup;
-			children = (
-				F5FF50C102E53EE101AEEDB1 /* English */,
-			);
-			name = FSAViewAssociationPanel.nib;
 			sourceTree = "<group>";
 		};
Index: trunk/Cocoa/F-Script Anywhere/Source/FSAController.h
===================================================================
--- trunk/Cocoa/F-Script Anywhere/Source/FSAController.h	(revision 223)
+++ trunk/Cocoa/F-Script Anywhere/Source/FSAController.h	(revision 224)
@@ -36,4 +36,6 @@
     FSAViewAssociationController *viewAssociationController;
     unsigned interpreterNum;
+    
+    NSCursor *bullseyeCursor;
 }
 
Index: trunk/Cocoa/F-Script Anywhere/Source/FSAController.m
===================================================================
--- trunk/Cocoa/F-Script Anywhere/Source/FSAController.m	(revision 223)
+++ trunk/Cocoa/F-Script Anywhere/Source/FSAController.m	(revision 224)
@@ -205,4 +205,8 @@
 - (IBAction)FSA_associateAndOpenBrowser:(id)sender
 {
+    if (viewAssociationController == nil) {
+	viewAssociationController = [[FSAViewAssociationController alloc] initWithFSAController: self];
+    }
+    [viewAssociationController captureOneView];
 }
 
Index: trunk/Cocoa/F-Script Anywhere/Source/FSAViewAssociationController.h
===================================================================
--- trunk/Cocoa/F-Script Anywhere/Source/FSAViewAssociationController.h	(revision 223)
+++ trunk/Cocoa/F-Script Anywhere/Source/FSAViewAssociationController.h	(revision 224)
@@ -32,10 +32,4 @@
 @interface FSAViewAssociationController : NSWindowController
 {
-    IBOutlet NSButton *captureButton;
-    IBOutlet NSButton *browseButton;
-    IBOutlet NSButton *associateButton;
-    IBOutlet NSTextField *descriptionField;
-    IBOutlet NSTextField *variableNameField;
-    IBOutlet NSTextField *statusField;
     NSCursor *bullseyeCursor;
     id selectedElement;
@@ -47,8 +41,8 @@
 - (id)initWithFSAController:(FSAController *)fsa;
 
-- (IBAction)update:(id)sender;
+- (void)captureOneView;
 - (IBAction)captureView:(id)sender;
-- (IBAction)defineVariable:(id)sender;
 - (IBAction)viewInObjectBrowser:(id)sender;
+- (void)alertWithString:(NSString *)alertString;
 
 @end
Index: trunk/Cocoa/F-Script Anywhere/Source/FSAViewAssociationController.m
===================================================================
--- trunk/Cocoa/F-Script Anywhere/Source/FSAViewAssociationController.m	(revision 223)
+++ trunk/Cocoa/F-Script Anywhere/Source/FSAViewAssociationController.m	(revision 224)
@@ -36,5 +36,5 @@
 - (id)initWithFSAController:(FSAController *)fsa;
 {
-    self = [super initWithWindowNibName: @"FSAViewAssociationPanel"];
+    self = [super init];
 
     if (self != nil) {
@@ -47,8 +47,4 @@
         if (label != nil) [[self window] setTitle: [NSString stringWithFormat: @"%@: %@", [[self window] title], label]];
         bullseyeCursor = [[NSCursor alloc] initWithImage: bullseyeImage hotSpot: NSMakePoint(6, 7)];
-        [[NSNotificationCenter defaultCenter] addObserver: self selector: @selector(controlTextDidChange:) name: NSControlTextDidChangeNotification object: variableNameField];
-        [[captureButton cell] setShowsStateBy: NSContentsCellMask | NSChangeGrayCellMask];
-        [captureButton setState: NSOffState];
-        [self update: nil];
     }
     return self;
@@ -65,33 +61,12 @@
 }
 
-- (IBAction)update:(id)sender;
-{
-    NSString *variableName = [variableNameField stringValue];
-    BOOL canAssignToVariable = NO;
-    [browseButton setEnabled: selectedElement != nil];
-    [statusField setStringValue: @""];
-    if ([variableName length] != 0) {
-        if (![FSInterpreter validateSyntaxForIdentifier: variableName]) {
-            [statusField setStringValue: @"Invalid name: contains spaces, punctuation or non-ASCII characters"];
-        } else if (selectedElement != nil) {
-            [statusField setStringValue: @"Click ÒAssociateÓ to assign to this variable"];
-            canAssignToVariable = YES;
-        }
-    }
-    [associateButton setEnabled: canAssignToVariable];
-    [variableNameField setEnabled: [captureButton state] == NSOffState];
-}
-
 - (void)stopCapturingVoluntarily:(BOOL)voluntary;
 {
     FSALog(@"stopping capture");
     [[NSNotificationCenter defaultCenter] removeObserver: self name: NSMenuWillSendActionNotification object: nil];
-    [captureButton setState: NSOffState];
-    [self update: nil];
     if (voluntary) {
         FSALog(@"voluntary!");
         [[self window] makeKeyAndOrderFront: self];
         [bullseyeCursor pop];
-        [variableNameField becomeFirstResponder];        
     }
 }
@@ -158,7 +133,5 @@
     
     FSALog(@"%4u>capturing one", capture);
-    [captureButton setState: NSOnState];
     [bullseyeCursor push];
-
 captureElement:
     [bullseyeCursor set];
@@ -192,10 +165,4 @@
         contentView = [eventWindow contentView];
         view = [[contentView superview] hitTest: [event locationInWindow]];
-        if (view == captureButton) {
-            [NSApp discardEventsMatchingMask: NSAnyEventMask & ~NSKeyUpMask beforeEvent: event];
-            FSALog(@"%4u<stop capture [capture button]", capture);
-            [self stopCapturingVoluntarily: YES];
-            NS_VOIDRETURN;
-        }
         if (view == nil) {
             [self captureOneView];
@@ -214,9 +181,9 @@
         [self _addElementToMenu: eventWindow];
     NS_HANDLER
-        [descriptionField setStringValue:
-            [NSString stringWithFormat: @"Çan exception occurred: %@È", localException]];
+	[self alertWithString:[NSString stringWithFormat: @"Çan exception occurred: %@È", localException]];
     NS_ENDHANDLER
     [NSMenu popUpContextMenu: viewHierarchyMenu withEvent: event forView: view];
-    if ([captureButton state] == NSOnState) goto captureElement;
+    [self stopCapturingVoluntarily: YES];
+//    if ([captureButton state] == NSOnState) goto captureElement;
     FSALog(@"%4u<stop capture [fell through to end]", capture);
 }
@@ -224,7 +191,5 @@
 - (IBAction)captureView:(id)sender
 {
-    [statusField setStringValue: @"Click inside one of this applicationÕs windows to select."];
     [selectedElement release]; selectedElement = nil;
-    [self update: nil];
     [self captureOneView];
 }
@@ -234,11 +199,9 @@
     FSALog(@"element selected: %@", element);
     NS_DURING
-        [descriptionField setStringValue: [element description]];
         [selectedElement release];
         selectedElement = [element retain];
         [[self window] orderFront: self];
     NS_HANDLER
-        [descriptionField setStringValue:
-            [NSString stringWithFormat: @"Çan exception occurred: %@È", localException]];
+	[self alertWithString:[NSString stringWithFormat: @"Çan exception occurred: %@È", localException]];
     NS_ENDHANDLER
     [viewHierarchyMenu release]; viewHierarchyMenu = nil;
@@ -248,5 +211,6 @@
 {
     [self setSelectedElement: [sender representedObject]];
-    [self captureOneView];
+    [system browse: selectedElement];
+//    [self captureOneView];
 }
 
@@ -259,26 +223,17 @@
 }
 
-- (void)controlTextDidChange:(NSNotification *)notification;
-{
-    [self update: nil];
-}
-
-- (IBAction)defineVariable:(id)sender;
-{
-    NS_DURING
-        NSString *variableName = [variableNameField stringValue];
-        [statusField setStringValue: @"AssociatingÉ"];
-        [interpreter setObject: selectedElement forIdentifier: variableName];
-        [statusField setStringValue: [NSString stringWithFormat: @"Assigned variable Ò%@Ó", variableName]];
-    NS_HANDLER
-        [statusField setStringValue: [NSString stringWithFormat: @"Assocation failed: %@", localException]];
-    NS_ENDHANDLER
-}
-
 - (IBAction)viewInObjectBrowser:(id)sender;
 {
     FSALog(@"system: %@", system);
     [system browse: selectedElement];
-    [statusField setStringValue: @"Opened object browser"];
+}
+
+- (void)alertWithString:(NSString *)alertString
+{
+    [NSAlert alertWithMessageText:alertString
+		    defaultButton:nil
+		  alternateButton:nil
+		      otherButton:nil
+	informativeTextWithFormat:nil];
 }
 
Index: trunk/Cocoa/F-Script Anywhere/Source/FSAnywhere.h
===================================================================
--- trunk/Cocoa/F-Script Anywhere/Source/FSAnywhere.h	(revision 223)
+++ trunk/Cocoa/F-Script Anywhere/Source/FSAnywhere.h	(revision 224)
@@ -8,6 +8,6 @@
  */
 
-#define FSA_VERSION "1.2b1"
-#define FSA_FSCRIPT_MIN_VERSION 0x1252001 /* 1.2.5d1 */
+#define FSA_VERSION "1.3"
+#define FSA_FSCRIPT_MIN_VERSION 0x1318000 /* 1.3.1 */
 #undef FSA_DEBUG
 
Index: trunk/Cocoa/F-Script Anywhere/Source/FSAnywhere.m
===================================================================
--- trunk/Cocoa/F-Script Anywhere/Source/FSAnywhere.m	(revision 223)
+++ trunk/Cocoa/F-Script Anywhere/Source/FSAnywhere.m	(revision 224)
@@ -11,3 +11,3 @@
 
 NSString * FSA_FScriptURL = @"http://www.fscript.org/";
-NSString * FSA_FScriptMinimumVersion = @"1.3.0";
+NSString * FSA_FScriptMinimumVersion = @"1.3.1";