Index: trunk/Cocoa/F-Script Anywhere/Source/F-Script Anywhere.xcodeproj/project.pbxproj
===================================================================
--- trunk/Cocoa/F-Script Anywhere/Source/F-Script Anywhere.xcodeproj/project.pbxproj	(revision 224)
+++ trunk/Cocoa/F-Script Anywhere/Source/F-Script Anywhere.xcodeproj/project.pbxproj	(revision 229)
@@ -8,4 +8,12 @@
 
 /* Begin PBXBuildFile section */
+		256669AE0A1D8DE30006AC79 /* DSCL.framework in Frameworks */ = {isa = PBXBuildFile; fileRef = 256669AD0A1D8DE30006AC79 /* DSCL.framework */; };
+		25666AD30A1D96DE0006AC79 /* DSCL.framework in CopyFiles */ = {isa = PBXBuildFile; fileRef = 256669AD0A1D8DE30006AC79 /* DSCL.framework */; };
+		25666ADA0A1D97B50006AC79 /* CoreFoundation.framework in Frameworks */ = {isa = PBXBuildFile; fileRef = 25666AD90A1D97B50006AC79 /* CoreFoundation.framework */; };
+		25666BE70A1DAA1D0006AC79 /* AddToProcMod in Resources */ = {isa = PBXBuildFile; fileRef = 25666BE10A1DAA050006AC79 /* AddToProcMod */; };
+		25666BEC0A1DAA410006AC79 /* procmod.m in Sources */ = {isa = PBXBuildFile; fileRef = 25666BEB0A1DAA410006AC79 /* procmod.m */; };
+		25666C100A1DACEB0006AC79 /* Foundation.framework in Frameworks */ = {isa = PBXBuildFile; fileRef = 25666C0F0A1DACEB0006AC79 /* Foundation.framework */; };
+		25666C4E0A1DAE4D0006AC79 /* Security.framework in Frameworks */ = {isa = PBXBuildFile; fileRef = 25666C4D0A1DAE4D0006AC79 /* Security.framework */; };
+		25666CA60A1DB1BD0006AC79 /* DSCL.framework in Frameworks */ = {isa = PBXBuildFile; fileRef = 256669AD0A1D8DE30006AC79 /* DSCL.framework */; };
 		25EADA9609CD2D7100BCD8E1 /* bytesex.c in Sources */ = {isa = PBXBuildFile; fileRef = 25EADA9509CD2D7100BCD8E1 /* bytesex.c */; };
 		E14C18BD05A4DE25000D4AF3 /* FSAInterpreterPanel.nib in Resources */ = {isa = PBXBuildFile; fileRef = F5680F7A020D0D0401AEEC37 /* FSAInterpreterPanel.nib */; };
@@ -113,4 +121,11 @@
 
 /* Begin PBXContainerItemProxy section */
+		25666BE50A1DAA120006AC79 /* PBXContainerItemProxy */ = {
+			isa = PBXContainerItemProxy;
+			containerPortal = 29B97313FDCFA39411CA2CEA /* Project object */;
+			proxyType = 1;
+			remoteGlobalIDString = 25666BE00A1DAA050006AC79 /* AddToProcMod */;
+			remoteInfo = AddToProcMod;
+		};
 		E1D652BB057666690054F5D1 /* PBXContainerItemProxy */ = {
 			isa = PBXContainerItemProxy;
@@ -130,4 +145,14 @@
 
 /* Begin PBXCopyFilesBuildPhase section */
+		25666ACD0A1D96D10006AC79 /* CopyFiles */ = {
+			isa = PBXCopyFilesBuildPhase;
+			buildActionMask = 2147483647;
+			dstPath = "";
+			dstSubfolderSpec = 10;
+			files = (
+				25666AD30A1D96DE0006AC79 /* DSCL.framework in CopyFiles */,
+			);
+			runOnlyForDeploymentPostprocessing = 0;
+		};
 		E1EE9A2B0575769600F2D92C /* CopyFiles */ = {
 			isa = PBXCopyFilesBuildPhase;
@@ -148,4 +173,10 @@
 		103DFC20016C16E20C000109 /* FSABundle.mm */ = {isa = PBXFileReference; fileEncoding = 30; lastKnownFileType = sourcecode.cpp.objcpp; path = FSABundle.mm; sourceTree = SOURCE_ROOT; };
 		1058C7A1FEA54F0111CA2CBB /* Cocoa.framework */ = {isa = PBXFileReference; lastKnownFileType = wrapper.framework; name = Cocoa.framework; path = /System/Library/Frameworks/Cocoa.framework; sourceTree = "<absolute>"; };
+		256669AD0A1D8DE30006AC79 /* DSCL.framework */ = {isa = PBXFileReference; lastKnownFileType = wrapper.framework; path = DSCL.framework; sourceTree = "<group>"; };
+		25666AD90A1D97B50006AC79 /* CoreFoundation.framework */ = {isa = PBXFileReference; lastKnownFileType = wrapper.framework; name = CoreFoundation.framework; path = /System/Library/Frameworks/CoreFoundation.framework; sourceTree = "<absolute>"; };
+		25666BE10A1DAA050006AC79 /* AddToProcMod */ = {isa = PBXFileReference; explicitFileType = "compiled.mach-o.executable"; includeInIndex = 0; path = AddToProcMod; sourceTree = BUILT_PRODUCTS_DIR; };
+		25666BEB0A1DAA410006AC79 /* procmod.m */ = {isa = PBXFileReference; fileEncoding = 4; lastKnownFileType = sourcecode.c.objc; path = procmod.m; sourceTree = "<group>"; };
+		25666C0F0A1DACEB0006AC79 /* Foundation.framework */ = {isa = PBXFileReference; lastKnownFileType = wrapper.framework; name = Foundation.framework; path = /System/Library/Frameworks/Foundation.framework; sourceTree = "<absolute>"; };
+		25666C4D0A1DAE4D0006AC79 /* Security.framework */ = {isa = PBXFileReference; lastKnownFileType = wrapper.framework; name = Security.framework; path = /System/Library/Frameworks/Security.framework; sourceTree = "<absolute>"; };
 		25EADA9509CD2D7100BCD8E1 /* bytesex.c */ = {isa = PBXFileReference; fileEncoding = 30; lastKnownFileType = sourcecode.c.c; name = bytesex.c; path = "../Darwin source/Commands/Apple/cctools/libstuff/bytesex.c"; sourceTree = SOURCE_ROOT; };
 		29B97316FDCFA39411CA2CEA /* main.m */ = {isa = PBXFileReference; fileEncoding = 30; lastKnownFileType = sourcecode.c.objc; path = main.m; sourceTree = "<group>"; };
@@ -173,5 +204,5 @@
 		E1EE98BD0575626E00F2D92C /* mach_inject.h */ = {isa = PBXFileReference; fileEncoding = 30; lastKnownFileType = sourcecode.c.h; path = mach_inject.h; sourceTree = "<group>"; tabWidth = 4; usesTabs = 1; };
 		E1EE9A2F0575769600F2D92C /* Info-Application.plist */ = {isa = PBXFileReference; fileEncoding = 4; lastKnownFileType = text.xml; path = "Info-Application.plist"; sourceTree = "<group>"; };
-		E1EE9A300575769600F2D92C /* F-Script Anywhere.app */ = {isa = PBXFileReference; explicitFileType = wrapper.application; includeInIndex = 0; path = "F-Script Anywhere.app"; sourceTree = BUILT_PRODUCTS_DIR; };
+		E1EE9A300575769600F2D92C /* F-Script Anywhere.app */ = {isa = PBXFileReference; includeInIndex = 0; lastKnownFileType = wrapper.application; path = "F-Script Anywhere.app"; sourceTree = BUILT_PRODUCTS_DIR; };
 		E1EE9A4F057576A700F2D92C /* F-Script Anywhere.bundle */ = {isa = PBXFileReference; explicitFileType = wrapper.cfbundle; includeInIndex = 0; path = "F-Script Anywhere.bundle"; sourceTree = BUILT_PRODUCTS_DIR; };
 		E1F3DF910579172A00E952A5 /* English */ = {isa = PBXFileReference; fileEncoding = 10; lastKnownFileType = text.plist.strings; name = English; path = English.lproj/FSA.strings; sourceTree = "<group>"; };
@@ -216,4 +247,13 @@
 
 /* Begin PBXFrameworksBuildPhase section */
+		25666BDF0A1DAA050006AC79 /* Frameworks */ = {
+			isa = PBXFrameworksBuildPhase;
+			buildActionMask = 2147483647;
+			files = (
+				25666CA60A1DB1BD0006AC79 /* DSCL.framework in Frameworks */,
+				25666C100A1DACEB0006AC79 /* Foundation.framework in Frameworks */,
+			);
+			runOnlyForDeploymentPostprocessing = 0;
+		};
 		E1D652010575B3D50054F5D1 /* Frameworks */ = {
 			isa = PBXFrameworksBuildPhase;
@@ -230,4 +270,7 @@
 				E1EE9A270575769600F2D92C /* Cocoa.framework in Frameworks */,
 				E1EE9A280575769600F2D92C /* Carbon.framework in Frameworks */,
+				256669AE0A1D8DE30006AC79 /* DSCL.framework in Frameworks */,
+				25666ADA0A1D97B50006AC79 /* CoreFoundation.framework in Frameworks */,
+				25666C4E0A1DAE4D0006AC79 /* Security.framework in Frameworks */,
 			);
 			runOnlyForDeploymentPostprocessing = 0;
@@ -252,11 +295,21 @@
 				E1EE9A4F057576A700F2D92C /* F-Script Anywhere.bundle */,
 				E1D652040575B3D50054F5D1 /* SCPatchLoader.bundle */,
+				25666BE10A1DAA050006AC79 /* AddToProcMod */,
 			);
 			name = Products;
 			sourceTree = "<group>";
 		};
+		256666B80A1D86D80006AC79 /* procmod */ = {
+			isa = PBXGroup;
+			children = (
+				25666BEB0A1DAA410006AC79 /* procmod.m */,
+			);
+			name = procmod;
+			sourceTree = "<group>";
+		};
 		29B97314FDCFA39411CA2CEA /* PatchTest */ = {
 			isa = PBXGroup;
 			children = (
+				25666C0F0A1DACEB0006AC79 /* Foundation.framework */,
 				F523EA31020CF1C701AEEC37 /* Shared sources */,
 				29B97315FDCFA39411CA2CEA /* Bundle sources */,
@@ -314,4 +367,7 @@
 			isa = PBXGroup;
 			children = (
+				25666C4D0A1DAE4D0006AC79 /* Security.framework */,
+				25666AD90A1D97B50006AC79 /* CoreFoundation.framework */,
+				256669AD0A1D8DE30006AC79 /* DSCL.framework */,
 				F59279FB01FED0C901AEEC37 /* Carbon.framework */,
 				1058C7A1FEA54F0111CA2CBB /* Cocoa.framework */,
@@ -416,4 +472,5 @@
 				F574ADD6020AC10F01AEEDB1 /* NJRScrollView.h */,
 				F574ADD5020AC10F01AEEDB1 /* NJRScrollView.m */,
+				256666B80A1D86D80006AC79 /* procmod */,
 				F5EFC2E7020A8F7F01AEEDB1 /* libMatch.h */,
 				F5EFC2E8020A8F7F01AEEDB1 /* libMatch.c */,
@@ -478,4 +535,28 @@
 
 /* Begin PBXNativeTarget section */
+		25666BE00A1DAA050006AC79 /* AddToProcMod */ = {
+			isa = PBXNativeTarget;
+			buildConfigurationList = 25666BED0A1DAA410006AC79 /* Build configuration list for PBXNativeTarget "AddToProcMod" */;
+			buildPhases = (
+				25666BDE0A1DAA050006AC79 /* Sources */,
+				25666BDF0A1DAA050006AC79 /* Frameworks */,
+			);
+			buildRules = (
+			);
+			buildSettings = {
+				GCC_ENABLE_FIX_AND_CONTINUE = YES;
+				GCC_MODEL_TUNING = G5;
+				INSTALL_PATH = "$(HOME)/bin";
+				PREBINDING = NO;
+				PRODUCT_NAME = AddToProcMod;
+				ZERO_LINK = YES;
+			};
+			dependencies = (
+			);
+			name = AddToProcMod;
+			productName = AddToProcMod;
+			productReference = 25666BE10A1DAA050006AC79 /* AddToProcMod */;
+			productType = "com.apple.product-type.tool";
+		};
 		E1D651FA0575B3D50054F5D1 /* Bundle Loader */ = {
 			isa = PBXNativeTarget;
@@ -539,4 +620,5 @@
 			buildPhases = (
 				E1EE9A030575769600F2D92C /* Headers */,
+				25666ACD0A1D96D10006AC79 /* CopyFiles */,
 				E1EE9A0F0575769600F2D92C /* Resources */,
 				E1EE9A180575769600F2D92C /* Sources */,
@@ -573,4 +655,5 @@
 				E1EE9AA60575939700F2D92C /* PBXTargetDependency */,
 				E1D652BC057666690054F5D1 /* PBXTargetDependency */,
+				25666BE60A1DAA120006AC79 /* PBXTargetDependency */,
 			);
 			name = Application;
@@ -656,4 +739,5 @@
 				E1EE9A4E057576A700F2D92C /* Bundle */,
 				E1D651FA0575B3D50054F5D1 /* Bundle Loader */,
+				25666BE00A1DAA050006AC79 /* AddToProcMod */,
 			);
 		};
@@ -672,4 +756,5 @@
 			buildActionMask = 2147483647;
 			files = (
+				25666BE70A1DAA1D0006AC79 /* AddToProcMod in Resources */,
 				E1D652AA0575B5F10054F5D1 /* SCPatchLoader.bundle in Resources */,
 				E1EE9AA90575945300F2D92C /* F-Script Anywhere.bundle in Resources */,
@@ -710,4 +795,12 @@
 
 /* Begin PBXSourcesBuildPhase section */
+		25666BDE0A1DAA050006AC79 /* Sources */ = {
+			isa = PBXSourcesBuildPhase;
+			buildActionMask = 2147483647;
+			files = (
+				25666BEC0A1DAA410006AC79 /* procmod.m in Sources */,
+			);
+			runOnlyForDeploymentPostprocessing = 0;
+		};
 		E1D651FE0575B3D50054F5D1 /* Sources */ = {
 			isa = PBXSourcesBuildPhase;
@@ -761,4 +854,9 @@
 
 /* Begin PBXTargetDependency section */
+		25666BE60A1DAA120006AC79 /* PBXTargetDependency */ = {
+			isa = PBXTargetDependency;
+			target = 25666BE00A1DAA050006AC79 /* AddToProcMod */;
+			targetProxy = 25666BE50A1DAA120006AC79 /* PBXContainerItemProxy */;
+		};
 		E1D652BC057666690054F5D1 /* PBXTargetDependency */ = {
 			isa = PBXTargetDependency;
@@ -833,4 +931,57 @@
 
 /* Begin XCBuildConfiguration section */
+		25666BEE0A1DAA410006AC79 /* Development */ = {
+			isa = XCBuildConfiguration;
+			buildSettings = {
+				COPY_PHASE_STRIP = NO;
+				FRAMEWORK_SEARCH_PATHS = (
+					"$(FRAMEWORK_SEARCH_PATHS)",
+					"$(SRCROOT)",
+				);
+				GCC_DYNAMIC_NO_PIC = NO;
+				GCC_ENABLE_FIX_AND_CONTINUE = YES;
+				GCC_GENERATE_DEBUGGING_SYMBOLS = YES;
+				GCC_MODEL_TUNING = G5;
+				GCC_OPTIMIZATION_LEVEL = 0;
+				INSTALL_PATH = "$(HOME)/bin";
+				PREBINDING = NO;
+				PRODUCT_NAME = AddToProcMod;
+				ZERO_LINK = YES;
+			};
+			name = Development;
+		};
+		25666BEF0A1DAA410006AC79 /* Deployment */ = {
+			isa = XCBuildConfiguration;
+			buildSettings = {
+				COPY_PHASE_STRIP = YES;
+				FRAMEWORK_SEARCH_PATHS = (
+					"$(FRAMEWORK_SEARCH_PATHS)",
+					"$(SRCROOT)",
+				);
+				GCC_ENABLE_FIX_AND_CONTINUE = NO;
+				GCC_GENERATE_DEBUGGING_SYMBOLS = NO;
+				GCC_MODEL_TUNING = G5;
+				PREBINDING = NO;
+				PRODUCT_NAME = AddToProcMod;
+				ZERO_LINK = NO;
+			};
+			name = Deployment;
+		};
+		25666BF00A1DAA410006AC79 /* Default */ = {
+			isa = XCBuildConfiguration;
+			buildSettings = {
+				FRAMEWORK_SEARCH_PATHS = (
+					"$(FRAMEWORK_SEARCH_PATHS)",
+					"$(SRCROOT)",
+				);
+				GCC_ENABLE_FIX_AND_CONTINUE = YES;
+				GCC_MODEL_TUNING = G5;
+				INSTALL_PATH = "$(HOME)/bin";
+				PREBINDING = NO;
+				PRODUCT_NAME = AddToProcMod;
+				ZERO_LINK = YES;
+			};
+			name = Default;
+		};
 		25EAD8EC09CD1E3900BCD8E1 /* Development */ = {
 			isa = XCBuildConfiguration;
@@ -952,5 +1103,8 @@
 			buildSettings = {
 				COPY_PHASE_STRIP = NO;
-				FRAMEWORK_SEARCH_PATHS = "$(SYSTEM_LIBRARY_DIR)/PrivateFrameworks";
+				FRAMEWORK_SEARCH_PATHS = (
+					"$(SYSTEM_LIBRARY_DIR)/PrivateFrameworks",
+					"$(SRCROOT)",
+				);
 				GCC_DYNAMIC_NO_PIC = NO;
 				GCC_ENABLE_FIX_AND_CONTINUE = YES;
@@ -989,5 +1143,8 @@
 				);
 				COPY_PHASE_STRIP = YES;
-				FRAMEWORK_SEARCH_PATHS = "$(SYSTEM_LIBRARY_DIR)/PrivateFrameworks";
+				FRAMEWORK_SEARCH_PATHS = (
+					"$(SYSTEM_LIBRARY_DIR)/PrivateFrameworks",
+					"$(SRCROOT)",
+				);
 				GCC_ENABLE_FIX_AND_CONTINUE = NO;
 				HEADER_SEARCH_PATHS = "\"$(SRCROOT)/../Darwin source/Commands/Apple/cctools/include\"";
@@ -1017,5 +1174,8 @@
 			isa = XCBuildConfiguration;
 			buildSettings = {
-				FRAMEWORK_SEARCH_PATHS = "$(SYSTEM_LIBRARY_DIR)/PrivateFrameworks";
+				FRAMEWORK_SEARCH_PATHS = (
+					"$(SYSTEM_LIBRARY_DIR)/PrivateFrameworks",
+					"$(SRCROOT)",
+				);
 				HEADER_SEARCH_PATHS = "\"$(SRCROOT)/../Darwin source/Commands/Apple/cctools/include\"";
 				INFOPLIST_FILE = "Info-Application.plist";
@@ -1062,4 +1222,14 @@
 
 /* Begin XCConfigurationList section */
+		25666BED0A1DAA410006AC79 /* Build configuration list for PBXNativeTarget "AddToProcMod" */ = {
+			isa = XCConfigurationList;
+			buildConfigurations = (
+				25666BEE0A1DAA410006AC79 /* Development */,
+				25666BEF0A1DAA410006AC79 /* Deployment */,
+				25666BF00A1DAA410006AC79 /* Default */,
+			);
+			defaultConfigurationIsVisible = 0;
+			defaultConfigurationName = Default;
+		};
 		25EAD8EB09CD1E3900BCD8E1 /* Build configuration list for PBXNativeTarget "Bundle" */ = {
 			isa = XCConfigurationList;